/************************************************************
* $Id: amem.c,v 1.5 2005/10/11 21:40:13 mechanoid Exp mechanoid $
*      
*   neural net based associative memory
*
*       OS : FreeBSD 4.6
* COMPILER : GNU project C and C++ Compiler (gcc-2.95.3)
*
*   AUTHOR : Evgeny S. Borisov
*
*  Glushkov Institute of Cybernetics
*  National Academy of Sciences of Ukraine
* 
*    http://mechanoid.narod.ru
*  e-mail : periodical@ukrpost.net
* 
************************************************************/
#include <gdk/gdk.h>
#include <stdio.h>
#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include <dirent.h>
#include <errno.h>

#include "nnet.h"
#include "nfiles.h"

#define OUT_FILE "out.bmp"

/* - - - - - - - - - - - - - - - - - - - */
void print_usage(char prog[]){
   fprintf(stderr,"usage:\n   %s -f <file.wgt> <file.bmp> [<out_image.bmp>]\n",prog);
   fprintf(stderr,"   %s -t <file.wgt> <ideal inputs dir>\n",prog);  
}

/* - - - - - - - - - - - - - - - - - - - */
int remember_patterns(char folder[]) {
   char filename[200];
   struct dirent *dp;
   DIR *dirp;

   if(!is_folder(folder)) { fprintf(stderr,"bad folder %s\n",folder); return 2; }
   dirp = opendir(folder);
   if(dirp == NULL){fprintf(stderr,"%s : %s\n",folder,strerror(errno));return 3;}
   weight_init();  
   while((dp = readdir(dirp)) != NULL){ 
	  if(is_bmp(dp->d_name)) {
		 snprintf(filename,200,"%s/%s",folder,dp->d_name);
		 if(nrdata_load(filename)) { return 1; }
		 store();
	  }
   }
   closedir(dirp);

   return 0;
}

/* - - - - - - - - - - - - - - - - - - - */
int recall_pattern(char filename[]) {
   if(nrdata_load(filename)) { return 1; }
   restore();
   return 0;
}

/* - - - - - - - - - - - - - - - - - - - */
int main(int argc, char *argv[]) { 
   if(argc<3) { print_usage(argv[0]); return 1; }
   gdk_init(&argc, &argv);
   
   if(!memcmp(argv[1],"-t",2)) { 
	  if(argc!=4) { print_usage(argv[0]); return 2; }
	  if(remember_patterns(argv[3])){ return 3; }
      if(weight_save(argv[2])){ return 4; }
	  return 0; 
   }

   if(!memcmp(argv[1],"-f",2)) { 
	  if(argc<4) { print_usage(argv[0]); return 2; }
	  if(weight_load(argv[2])) return 5;
	  recall_pattern(argv[3]);
      if(argc==4) {nrdata_save(OUT_FILE);} else {nrdata_save(argv[4]);} 
	  return 0; 
   }

   print_usage(argv[0]);
     
   return 7;
}

