/************************************************************
* $Id: nnet.h,v 1.3 2005/10/10 08:34:20 mechanoid Exp $
*       
*   neural net based associative memory
*
*       OS : FreeBSD 4.6
* COMPILER : GNU project C and C++ Compiler (gcc-2.95.3)
*
*   AUTHOR : Evgeny S. Borisov
*
*  Glushkov Institute of Cybernetics
*  National Academy of Sciences of Ukraine
* 
*    http://mechanoid.narod.ru
*  e-mail : periodical@ukrpost.net
* 
************************************************************/
#ifndef NNET_H
#define NNET_H
#include "nparam.h"

/* activation function parameters */
#define LO -1
#define HI  1
#define T   0

#define MAX_ITERATION 100

/* - - - - - - - - - - - - - - - - - - - */
//typedef double weight_t;
typedef int    weight_t;
typedef char   data_t;

extern data_t   output[OUTSIZE]; // output vector
extern data_t   output_prev[OUTSIZE]; // prev. output vector
extern weight_t weight[OUTSIZE][OUTSIZE]; // weight matrix

/* - - - - - - - - - - - - - - - - - - - */
void weight_init(); // init weight matrix
weight_t state(int out); // calculate state of neuron number out
void step(); // calculate net output 
void store(); // remember input
void restore();

#endif
