#!/bin/sh

# $Id: run.sh,v 1.2 2005/10/11 21:40:13 mechanoid Exp mechanoid $
#
#   neural net based associative memory (demo script)
#
#   AUTHOR : Evgeny S. Borisov
#
#  Glushkov Institute of Cybernetics
#  National Academy of Sciences of Ukraine
# 
#    http://www.mechanoid.kiev.ua
#  e-mail : nn@mechanoid.kiev.ua

DIR_DATA='data'
SUBDIR_OUTPUT='out'
SUBDIR_TEST='test'
SUBDIR_IDEAL='ideal'
FILE_WEIGHT='amem.wgt'

HTML_REPORT_FILE='REPORT.html'
HTML_HEADER='<html><style> table { border-spacing: 9px; border: 1px dashed #000000; width:50% } td { font-family:verdana,tahoma,arial; font-size:12px;} td.capt { text-align:right; border-right: 1px dashed #000000; } </style><body><table><tbody><tr><td class=capt>ideal: </td>'
HTML_IMG_BEGIN='<td><img src="'
HTML_IMG_END='"></td>'
HTML_TABLE_INPUT='</tr><tr><td class=capt>test: </td>'
HTML_TABLE_OUTPUT='</tr><tr><td class=capt>output: </td>'
HTML_FOOTER='</tr></tbody></table></body></html>'

# make weight matrix
./amem -t "$DIR_DATA/$FILE_WEIGHT" "$DIR_DATA/$SUBDIR_IDEAL" 

rm $DIR_DATA/$SUBDIR_OUTPUT/*.bmp

# run net
for f in "$DIR_DATA/$SUBDIR_TEST/"*.bmp; do
   ./amem -f "$DIR_DATA/$FILE_WEIGHT" "$f" "$DIR_DATA/$SUBDIR_OUTPUT/`basename $f`"
done

# make html report
echo $HTML_HEADER > $HTML_REPORT_FILE
for f in "$DIR_DATA/$SUBDIR_IDEAL/"*.bmp; do
   echo $HTML_IMG_BEGIN$f$HTML_IMG_END >> $HTML_REPORT_FILE
done
echo $HTML_TABLE_INPUT >> $HTML_REPORT_FILE
for f in "$DIR_DATA/$SUBDIR_TEST/"*.bmp; do
   echo $HTML_IMG_BEGIN$f$HTML_IMG_END >> $HTML_REPORT_FILE
done
echo $HTML_TABLE_OUTPUT >> $HTML_REPORT_FILE

for f in "$DIR_DATA/$SUBDIR_OUTPUT/"*.bmp; do
   echo $HTML_IMG_BEGIN$f$HTML_IMG_END >> $HTML_REPORT_FILE
done
echo $HTML_FOOTER >> $HTML_REPORT_FILE
